<?php

namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Utilities;

class Ger15300AgrupamentoUnidadeController extends \Teknisa\CADEST\Controllers\TeknisaCrud {

    protected $dataSourceName = 'filgrupfili_filial';
    protected $utilities;
    
     public function __construct($crudService, ParameterBag $parameterBag, $connection, $environment, Utilities $utilities) {
        $this->environment = $environment;
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
        $this->utilities = $utilities;
    }
	
    public function saveUnidade(DTO\Request\DataSet $request, DTO\Response $response) {
        try{
            $NRORG = $this->environment->getNRORG();
		    $data = $request->getDataSet()->getRows();
		    $row = $request->getDataSet()->getRows()[0]; 
		
		    $query = 'SELECT CDFILIAL FROM FILGRUPFILI WHERE CDGRUPFILI = :CDGRUPFILI AND CDFILIAL = :CDFILIAL GROUP BY CDFILIAL';
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDGRUPFILI" => $data[0]['CDGRUPFILI'],
                "CDFILIAL" => $data[0]['CDFILIAL']
            ));
            $result = $stmt->fetchAll();

            if(count($result) > 0 && $row['__is_new']) {
                throw new \Exception('Essa unidade já foi cadastrado para essse agrupamento');    
            }
            
            $query = 'INSERT INTO FILGRUPFILI (CDFILIAL, CDGRUPFILI, NRORG) VALUES (:CDFILIAL, :CDGRUPFILI, :NRORG)';
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDFILIAL" => $data[0]['CDFILIAL'],
                "CDGRUPFILI" => $data[0]['CDGRUPFILI'],
                "NRORG" => $NRORG
            ));
            $this->utilities->saveCollectedData($row['CDFILIAL'],'saveUnidade','1158');
             
        } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
        
	}

}